package acube.framework.web.result;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.Result;


/**
 * 
 * Projet proto.
 *
 * @author MAE
 *
 */
public class CSVResult implements Result {

    public void execute(
            ActionInvocation invocation) throws Exception {
        HttpServletResponse res = ServletActionContext.getResponse();
        PrintWriter out = res.getWriter();
        
        String separator = ";";
        
        res.setHeader("content-type", "text/csv");

        Object o = invocation.getAction();
        
        if (o instanceof CSVAware) {
           CSVAware a = (CSVAware) o;
           
           String[] h = a.getHeader();
           
           for(int i=0; i<h.length; i++) {
               out.print("\"");
               out.print(h[i]);
               out.print("\"");
               if(i<h.length-1) {
                   out.print(separator);
               }
           }

           out.println();

           String[][] d = a.getData();
           
           for(int l=0; l<d.length; l++) {
               for(int c=0; c<h.length; c++) {
                   out.print("\"");
                   out.print(d[l][c]);
                   out.print("\"");
                   if(c<h.length-1) {
                       out.print(separator);
                   }
               }
               out.println();
           }
           
           out.flush();
        }
        
    }

}
