package acube.framework.captcha;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;
import java.util.Random;

/**
 * Projet fwacubej2ee.
 * 
 * @author EDS
 * 
 */
public class CaptchaTools {

    /**
     * singleton.
     */
    private static CaptchaTools instance = new CaptchaTools();

    /**
     * Constructor
     */
    private CaptchaTools() {
    }

    /**
     * @return CaptchaManager's instance.
     */
    public static CaptchaTools getInstance() {

        return CaptchaTools.instance;
    }

    /**
     * @return a Random String with MD5 encoding
     * @throws NoSuchAlgorithmException md5 wanted
     */
    public String getSessionId() throws NoSuchAlgorithmException {

        Random random = new Random();
        int test = random.nextInt(CaptchaParameters.RANDOM_MAX_INT);
        StringBuffer sId = new StringBuffer();
        MessageDigest msgDigest = MessageDigest.
        getInstance(CaptchaParameters.ALGORITHM_USE);
        StringBuffer sb = new StringBuffer(Integer.toString(test));
        sb.append(Long.toString((new Date().getTime())));
        msgDigest.update((sb.toString()).getBytes());
        byte digest[] = msgDigest.digest();

        for (int i = 0; i < digest.length; ++i) {
            int value = digest[i];
            if (value < 0) {
                value += CaptchaParameters.RANDOM_KEY_INT;
            }
            sId.append(Integer.toHexString(
                value));
        }
        return (sId.toString());
    }
}
